{ Diese Unit enthlt Routinen fr die zufllige Erstellung, Sicherung und
  Anzeige von Irrgrten:

 Der Datentyp TIrrgarten enthlt:
   - Breite und Lnge des Irrgartens
   - Einen Irrgarten als TIrrgartenFeld = array[0..102,0..102] of integer
         wobei die Feldelemente folgende Werte annehmen knnen:
                         0: Grenze
                         1: Weg
                         2: IrrWeg
                         3: Anfang (-Feld)
                         4: Ende   (-Feld)
   - Eine Anfangs- und Endposition als TPosition = record x,y: integer end;

Routinen, die auf diesen Datentyp angewandt werden knnen:

procedure Loesche_Irrgarten(var IrrFeld: TIrrgarten);
  Lscht den gesamten Irrgarten und initialisert diesen neu.

procedure Erstelle_Irrgarten(var IrrFeld: TIrrgarten; Breite, Hoehe: integer);
  Erstellt einen neuen zuflligen Irrgarten mit vorgegebener Breite und Hhe.
  Die auf jeden Fall exisitierende Lsung wird allerdings nicht festgehalten,
  d. h. alle Wege sind Irrweg (IrrWeg=2 s. o.)

procedure Erstelle_Irrgarten_mit_Loesung(var IrrFeld: TIrrgarten; Breite, Hoehe: integer);
  Ertellt einen neuen zuflligen Irrgarten mit vorgegebener Breite und Hhe.
  Die auf jeden Fall exisitierende Lsung wird festgehalten,
  d. h. es wird zwischen richtigen Wegen (Weg=1 s. o.) und Irrwegen (Irrweg=2 s. o.)
  unterschieden.

procedure Erstelle_Irrgarten_als_Text(var Irrgarten: TTextIrrgarten; var StartX, StartY: integer; Groesse: integer);
  Erstellt einen zuflligen Irrgarten als Array[1..n,1..n] of Char.
  Diese Erstellungsroutine wird ntig fr die Schlerlsung.


procedure Lade_Irrgarten(var IrrFeld: TIrrgarten; dateiname: string);
  ffnet einen als Textdatei vorliegenden Irrgarten.

procedure Speichere_Irrgarten(IrrFeld: TIrrgarten; dateiname: string);
  Speichert einen zuvor zufllig erstellten Irrgarten als Textdatei.

procedure Zeige_Irrgarten_2Dim_als_Text(IrrFeld: TIrrgarten; var PB: TPaintBox; G, W, IW, A, E: boolean);
  Zeigt einen Irrgarten in einer Paintbox an. Man kann dabei whlen, welche
  Teile des Irrgartens gezeigt werden sollen. Im einzelnen:
     - G:  Grenzen sichtbar / unsichtbar (true / false)
     - W:  richtige Wege sichtbar / unsichtbar (true / false)
     - IW: Irrwege sichtbar / unsichtbar (true / false)
     - A:  Anfang sichtbar / unsichtbar (true / false)
     - E:  Ende sichtbar / unsichtbar (true / false)
  Zustzlich werden die Zeichen ausgegeben, welche die Grenze (#), den Start (S), das Ziel (Z) und
  einen bereits besuchten Weg (O) symbolisieren.

procedure Zeige_Irrgarten_2Dim_als_Grafik(IrrFeld: TIrrgarten; var PB: TPaintBox; G, W, IW, A, E: boolean);
  Zeigt einen Irrgarten in einer Paintbox an. Man kann dabei whlen, welche
  Teile des Irrgartens gezeigt werden sollen. Im einzelnen:
     - G:  Grenzen sichtbar / unsichtbar (true / false)
     - W:  richtige Wege sichtbar / unsichtbar (true / false)
     - IW: Irrwege sichtbar / unsichtbar (true / false)
     - A:  Anfang sichtbar / unsichtbar (true / false)
     - E:  Ende sichtbar / unsichtbar (true / false)
  Der Irrgarten ist so gestaltet, wie ein Irrgarten normalerweise aussieht.

procedure Zeige_Irrgarten_3Dim(IrrFeld: TIrrgarten; var PB: TPaintBox; Pos: TPosition; Dir: TRichtung);
  Noch nicht implementiert!!!!!!

-------------------------------------------------- 05.10.2000 Garmann ---------------------------------}

unit U_irrga;

interface

uses ExtCtrls, Graphics;

const max= 101;

      ost=1; nord=2; west=3; sued=4;

      Grenze= 0; Weg   = 1; IrrWeg= 2; Anfang= 3; Ende  = 4;

type TIrrgartenFeldinhalt = Grenze..Ende;
     TIrrgartenFeld = array[0..max+1,0..max+1] of TIrrgartenFeldinhalt;
     TPosition= Record
                  x: 1..max-1;
                  y: 1..max-1;
                end;
     TRichtung= ost..sued;
     TIrrgarten= Record
                   Breite, Hoehe: integer;
                   Feld: TIrrgartenFeld;
                   PosAnfang, PosEnde: TPosition;
                 end;
     TAnzeigen= Set of TIrrgartenFeldinhalt;

     TTextIrrgarten= array[1..max,1..max] of Char;

Const Farbe: array[TIrrgartenFeldinhalt] of TColor= (clBlack,clLime,ClWhite,clLime,clRed);

procedure Loesche_Irrgarten(var IrrFeld: TIrrgarten);
procedure Erstelle_Irrgarten(var IrrFeld: TIrrgarten; Breite, Hoehe: integer);
procedure Erstelle_Irrgarten_mit_Loesung(var IrrFeld: TIrrgarten; Breite, Hoehe: integer);
procedure Erstelle_Irrgarten_als_Text(var Irrgarten: TTextIrrgarten; var StartX, StartY: integer; Groesse: integer);

procedure Lade_Irrgarten(var IrrFeld: TIrrgarten; dateiname: string);
procedure Speichere_Irrgarten(IrrFeld: TIrrgarten; dateiname: string);
procedure Zeige_Irrgarten_2Dim_als_Text(IrrFeld: TIrrgarten; var PB: TPaintBox;
                             G, W, IW, A, E: boolean);
procedure Zeige_Irrgarten_2Dim_als_Grafik(IrrFeld: TIrrgarten; var PB: TPaintBox;
                             G, W, IW, A, E: boolean);
procedure Zeige_Irrgarten_3Dim(IrrFeld: TIrrgarten; var PB: TPaintBox; Pos: TPosition; Dir: TRichtung);

implementation


procedure Loesche_Irrgarten(var IrrFeld: TIrrgarten);
var x, y: integer;
begin
  for x:= 0 to Irrfeld.Breite+1 do for y:= 0 to Irrfeld.Hoehe+1 do IrrFeld.Feld[x,y]:= Grenze;
end;

procedure Erstelle_Irrgarten_mit_Loesung(var IrrFeld: TIrrgarten; Breite, Hoehe: integer);
var Belegte_Felder: integer;

  procedure Erstelle_Ersten_Weg(var Laenge: integer); { den richtigen Lsungsweg }
  var
      Dir: Integer;
      kannsetzen: boolean;
      RichtungOk: boolean;
      x,y: integer;
      Zufallszahl: integer;
  begin
    Laenge:= 0;
    while (Laenge<3*Irrfeld.Breite) or (Laenge<3*Irrfeld.Hoehe) do
    begin
      Laenge:= 0;
      Loesche_Irrgarten(IrrFeld);
      Dir:= ost;
      x:= 2;
      y:= (Irrfeld.Hoehe div 4)*2;
      IrrFeld.Feld[0,y]:= Grenze;
      IrrFeld.Feld[1,y]:= Anfang;
      IrrFeld.PosAnfang.x:= 1;
      IrrFeld.PosAnfang.y:= y;
      IrrFeld.Feld[2,y]:= Weg;
      kannsetzen:= true;
      while kannsetzen and (x>1) and (x<Irrfeld.Breite) and (y>1) and (y<Irrfeld.Hoehe) do
      begin
        Repeat
          Zufallszahl:= Random(6)+1;
          if Zufallszahl<=4 then Dir:= Zufallszahl;
          Case Dir of
            ost:  RichtungOk:= (IrrFeld.Feld[x+2,y]=Grenze);
            nord: RichtungOk:= (IrrFeld.Feld[x,y-2]=Grenze);
            west: RichtungOk:= (IrrFeld.Feld[x-2,y]=Grenze);
            sued: RichtungOk:= (IrrFeld.Feld[x,y+2]=Grenze);
          end;
        until RichtungOk;
        Case Dir of
          ost:  begin
                  IrrFeld.Feld[x+1,y]:= Weg;
                  IrrFeld.Feld[x+2,y]:= Weg;
                  x:= x+2;
                end;
          west: begin
                  IrrFeld.Feld[x-1,y]:= Weg;
                  IrrFeld.Feld[x-2,y]:= Weg;
                  x:= x-2;
                end;
          sued: begin
                  IrrFeld.Feld[x,y+1]:= Weg;
                  IrrFeld.Feld[x,y+2]:= Weg;
                  y:= y+2;
                end;
          nord: begin
                  IrrFeld.Feld[x,y-1]:= Weg;
                  IrrFeld.Feld[x,y-2]:= Weg;
                  y:= y-2;
                end;
        end;

        Laenge:= Laenge+2;
        kannsetzen:= (IrrFeld.Feld[x+2,y]=Grenze) or (IrrFeld.Feld[x-2,y]=Grenze) or
                     (IrrFeld.Feld[x,y-2]=Grenze) or (IrrFeld.Feld[x,y+2]=Grenze);
      end;
      if not kannsetzen then Laenge:= 0
                        else begin
                               case Dir of
                                 ost: begin
                                        IrrFeld.Feld[x-1,y]:= Ende;
                                        IrrFeld.PosEnde.x:= x-1;
                                        IrrFeld.PosEnde.y:= y;
                                      end;
                                 west: begin
                                         IrrFeld.Feld[x+1,y]:= Ende;
                                         IrrFeld.PosEnde.x:= x+1;
                                         IrrFeld.PosEnde.y:= y;
                                       end;
                                 sued: begin
                                         IrrFeld.Feld[x,y-1]:= Ende;
                                         IrrFeld.PosEnde.x:= x;
                                         IrrFeld.PosEnde.y:= y-1;
                                       end;
                                 nord: begin
                                         IrrFeld.Feld[x,y+1]:= Ende;
                                         IrrFeld.PosEnde.x:= x;
                                         IrrFeld.PosEnde.y:= y+1;
                                       end;
                               end;
                               IrrFeld.Feld[x,y]:= Grenze;
                             end;
    end;
  end;

  procedure Erstelle_Irrwege(Restfelder: integer); { also die falschen Wege }
  var Rest: integer;
      Dir: Integer;
      kannsetzen: boolean;
      RichtungOk: boolean;
      x,y: integer;
      Zufallszahl: integer;

  begin
    While Restfelder>0 do
    begin
      repeat
        x:= (random(Irrfeld.Breite div 2)+1)*2;
        y:= (random(Irrfeld.Hoehe div 2)+1)*2;
        Dir:= Random(4)+1;
      until (Weg = IrrFeld.Feld[x,y]) or (IrrWeg = IrrFeld.Feld[x,y]);

      kannsetzen:= ((IrrFeld.Feld[x+2,y]=Grenze) and (x+2<Irrfeld.Breite)) or
                   ((IrrFeld.Feld[x-2,y]=Grenze) and (x-2>1)) or
                   ((IrrFeld.Feld[x,y-2]=Grenze) and (y-2>1)) or
                   ((IrrFeld.Feld[x,y+2]=Grenze) and (y+2<Irrfeld.Hoehe));

      while kannsetzen and (x>1) and (x<Irrfeld.Breite) and (y>1) and (y<Irrfeld.Hoehe) do
      begin
        Repeat
          Zufallszahl:= Random(6)+1;
          if Zufallszahl<=4 then Dir:= Zufallszahl;
          Case Dir of
            ost:  RichtungOk:= (IrrFeld.Feld[x+2,y]=Grenze) and (x+2<Irrfeld.Breite);
            nord: RichtungOk:= (IrrFeld.Feld[x,y-2]=Grenze) and (y-2>1);
            west: RichtungOk:= (IrrFeld.Feld[x-2,y]=Grenze) and (x-2>1);
            sued: RichtungOk:= (IrrFeld.Feld[x,y+2]=Grenze) and (y+2<Irrfeld.Hoehe);
          end;
        until RichtungOk;
        Case Dir of
          ost:  begin
                  IrrFeld.Feld[x+1,y]:= IrrWeg;
                  IrrFeld.Feld[x+2,y]:= IrrWeg;
                  x:= x+2;
                end;
          west: begin
                  IrrFeld.Feld[x-1,y]:= IrrWeg;
                  IrrFeld.Feld[x-2,y]:= IrrWeg;
                  x:= x-2;
                end;
          sued: begin
                  IrrFeld.Feld[x,y+1]:= IrrWeg;
                  IrrFeld.Feld[x,y+2]:= IrrWeg;
                  y:= y+2;
                end;
          nord: begin
                  IrrFeld.Feld[x,y-1]:= IrrWeg;
                  IrrFeld.Feld[x,y-2]:= IrrWeg;
                  y:= y-2;
                end;
        end;

        Restfelder:= Restfelder-2;
        kannsetzen:= ((IrrFeld.Feld[x+2,y]=Grenze) and (x+2<Irrfeld.Breite)) or
                     ((IrrFeld.Feld[x-2,y]=Grenze) and (x-2>1)) or
                     ((IrrFeld.Feld[x,y-2]=Grenze) and (y-2>1)) or
                     ((IrrFeld.Feld[x,y+2]=Grenze) and (y+2<Irrfeld.Hoehe));
      end;

    end;
  end;


begin
  randomize;                              { Zufallsgenerator starten   }
  IrrFeld.Breite:= Breite;                { Irrgartenbreite setzen     }
  IrrFeld.Hoehe:= Hoehe;                  { Irrgartenhhe setzen       }
  Erstelle_Ersten_Weg(Belegte_Felder);    { Zuert den Lsungsweg bauen }
  Erstelle_Irrwege((Irrfeld.Hoehe-1)*(Irrfeld.Breite-1) div 2-Belegte_Felder);
                                          { danach die Irrwege anbauen }
end;

procedure Erstelle_Irrgarten(var IrrFeld: TIrrgarten; Breite, Hoehe: Integer);
var i, j: integer;
begin
  Erstelle_Irrgarten_mit_Loesung(IrrFeld, Breite, Hoehe);
  for i:= 1 to Irrfeld.Breite
    do for j:= 1 to Irrfeld.Hoehe
         do if IrrFeld.Feld[i,j]=Weg
              then IrrFeld.Feld[i,j]:= IrrWeg;
end;

procedure Erstelle_Irrgarten_als_Text(var Irrgarten: TTextIrrgarten; var StartX, StartY: integer; Groesse: integer);
var i, j: integer;
    IrrFeld: TIrrgarten;
begin
  Erstelle_Irrgarten_mit_Loesung(Irrfeld, Groesse, Groesse);
  for i:= 1 to Groesse
    do for j:= 1 to Groesse do
      case Irrfeld.Feld[i,j] of
        Grenze: Irrgarten[i,j]:= '#';
        Weg, IrrWeg: Irrgarten[i,j]:= ' ';
        Anfang: Irrgarten[i,j]:= 'S';
        Ende: Irrgarten[i,j]:= 'Z';
      end;
  StartX:= Irrfeld.PosAnfang.x;
  StartY:= Irrfeld.PosAnfang.y;
end;

procedure Lade_Irrgarten(var IrrFeld: TIrrgarten; dateiname: string);
var f: textfile;
    str: string;
    i, j: integer;
begin
         assignfile(f,dateiname);
         reset(f);

         Irrfeld.Hoehe:= 0;
         Irrfeld.Breite:= 0;
         while not eof(f)
         do begin
              inc(Irrfeld.Hoehe);
              readln(f,str);
              Irrfeld.Breite:= Irrfeld.breite+length(str);
            end;
         Irrfeld.Breite:= (Irrfeld.Breite + Irrfeld.Hoehe div 2) div Irrfeld.Hoehe;
         closefile(f);

         reset(f);
         j:= 0;
         while not eof(f)
         do begin
              inc(j);
              readln(f,str);
              for i:= 1 to Irrfeld.Breite
              do begin
                   case str[i] of
                     ' ': begin
                            Irrfeld.Feld[i,j]:= IrrWeg;
                            if (j=1) or (i=1)
                            then begin
                                   Irrfeld.Feld[i,j]:= Anfang;
                                   Irrfeld.PosAnfang.x:= i;
                                   Irrfeld.PosAnfang.y:= j;
                                 end;
                            if (j=Irrfeld.Hoehe) or (i=Irrfeld.Breite)
                            then begin
                                   Irrfeld.Feld[i,j]:= Ende;
                                   Irrfeld.PosEnde.x:= i;
                                   Irrfeld.PosEnde.y:= j;
                                 end;
                          end;
                     else begin
                            Irrfeld.Feld[i,j]:= Grenze;
                          end;
                   end;
                 end;
            end;
         closefile(f);
end;


procedure Speichere_Irrgarten(IrrFeld: TIrrgarten; dateiname: string);
var f: textfile;
    str: string;
    i, j: integer;
begin
         assignfile(f,dateiname);
         rewrite(f);
         for j:= 1 to Irrfeld.Hoehe
         do begin
              str:= '';
              for i:= 1 to Irrfeld.Breite
              do begin
                   if Grenze = Irrfeld.Feld[i,j]
                   then str:= str+ '#'
                   else str:= str+ ' ';
                 end;
              writeln(f,str);
            end;
         closefile(f);
end;

procedure Zeige_Irrgarten_2Dim_als_Text(IrrFeld: TIrrgarten; var PB: TPaintBox;
                             G, W, IW, A, E: boolean);
var Horizontal_Abstand, Vertikal_Abstand, Abstand: integer;
    x,y: integer;
    i: TIrrgartenFeldinhalt;
    Anzeigen: TAnzeigen;
begin
  Anzeigen:= [];
  if G then Anzeigen:= Anzeigen+ [Grenze];
  if W then Anzeigen:= Anzeigen+ [Weg];
  if IW then Anzeigen:= Anzeigen+ [IrrWeg];
  if A then Anzeigen:= Anzeigen+ [Anfang];
  if E then Anzeigen:= Anzeigen+ [Ende];
  Vertikal_Abstand:= PB.Width div Irrfeld.Breite;
  Horizontal_Abstand:= PB.Height div Irrfeld.Hoehe;
  if Horizontal_Abstand<Vertikal_Abstand then Abstand:= Horizontal_Abstand else Abstand:= Vertikal_Abstand;
  PB.Canvas.Font.Size:= Abstand;
  while PB.Canvas.TextHeight('X')>=Abstand do PB.Canvas.Font.Size:= PB.Canvas.Font.Size - 1;
  for y:= 1 to Irrfeld.Hoehe do for x:= 1 to Irrfeld.Breite do
  begin
        for i:= Grenze to Ende do
        begin
          if (i = IrrFeld.Feld[x,y]) and (i in Anzeigen)
          then begin
                 PB.Canvas.Pen.Color:= Farbe[i];
                 PB.Canvas.Brush.Color:= Farbe[i];
                 PB.Canvas.Rectangle(x*Abstand,y*Abstand,
                                     x*Abstand-Abstand+1,y*Abstand-Abstand+1);
                 Case Irrfeld.Feld[x,y] of
                   Grenze: begin
                             PB.Canvas.Font.Color:= clWhite;
                             PB.Canvas.TextOut((x-1)*Abstand+5,(y-1)*Abstand+1,'#');
                           end;
                   Anfang: begin
                             PB.Canvas.Font.Color:= clBlack;
                             PB.Canvas.TextOut((x-1)*Abstand+5,(y-1)*Abstand+1,'S');
                           end;
                   Ende:  begin
                             PB.Canvas.Font.Color:= clBlack;
                             PB.Canvas.TextOut((x-1)*Abstand+5,(y-1)*Abstand+1,'Z');
                           end;
                   Weg:    begin
                             PB.Canvas.Font.Color:= clBlack;
                             PB.Canvas.TextOut((x-1)*Abstand+5,(y-1)*Abstand+1,'O');
                           end;
                 end;

               end;
        end;
  end;

end;


procedure Zeige_Irrgarten_2Dim_als_Grafik(IrrFeld: TIrrgarten; var PB: TPaintBox;
                             G, W, IW, A, E: boolean);
var Horizontal_Abstand, Vertikal_Abstand, Abstand: integer;
    x,y: integer;
    i: TIrrgartenFeldinhalt;
    Anzeigen: TAnzeigen;
begin
  Anzeigen:= [];
  if G then Anzeigen:= Anzeigen+ [Grenze];
  if W then Anzeigen:= Anzeigen+ [Weg];
  if IW then Anzeigen:= Anzeigen+ [IrrWeg];
  if A then Anzeigen:= Anzeigen+ [Anfang];
  if E then Anzeigen:= Anzeigen+ [Ende];
{  PB.Refresh;}
  Vertikal_Abstand:= PB.Width div (Irrfeld.Breite div 2);
  Horizontal_Abstand:= PB.Height div (Irrfeld.Hoehe div 2);
  if Horizontal_Abstand<Vertikal_Abstand then Abstand:= Horizontal_Abstand else Abstand:= Vertikal_Abstand;
  for y:= 1 to Irrfeld.Hoehe do for x:= 1 to Irrfeld.Breite do
  begin
    if odd(y)
    then  begin
      if odd(x)
      then begin
        for i:= Grenze to Ende do
        begin
          if (i = IrrFeld.Feld[x,y]) and (i in Anzeigen)
            then PB.Canvas.Pixels[(x div 2)*Abstand,(y div 2)*Abstand]:= Farbe[i];
        end;
      end
      else begin
        for i:= Grenze to Ende do
        begin
          if (i = IrrFeld.Feld[x,y]) and (i in Anzeigen)
          then begin
                 PB.Canvas.Pen.Color:= Farbe[i];
                 PB.Canvas.MoveTo((x div 2)*Abstand-1,(y div 2)*Abstand);
                 PB.Canvas.LineTo((x div 2)*Abstand-Abstand,(y div 2)*Abstand);
               end;
        end;
      end;
    end
    else begin
      if odd(x)
      then begin
        for i:= Grenze to Ende do
        begin
          if (i = IrrFeld.Feld[x,y]) and (i in Anzeigen)
          then begin
                 PB.Canvas.Pen.Color:= Farbe[i];
                 PB.Canvas.MoveTo((x div 2)*Abstand,(y div 2)*Abstand-1);
                 PB.Canvas.LineTo((x div 2)*Abstand,(y div 2)*Abstand-Abstand);
               end;
        end;
      end
      else begin
        for i:= Grenze to Ende do
        begin
          if (i = IrrFeld.Feld[x,y]) and (i in Anzeigen)
          then begin
                 PB.Canvas.Pen.Color:= Farbe[i];
                 PB.Canvas.Brush.Color:= Farbe[i];
                 PB.Canvas.Rectangle((x div 2)*Abstand,(y div 2)*Abstand,
                                     (x div 2)*Abstand-Abstand+1,(y div 2)*Abstand-Abstand+1);
               end;
        end;
      end;
    end;
  end;

end;

procedure Zeige_Irrgarten_3Dim(IrrFeld: TIrrgarten; var PB: TPaintBox; Pos: TPosition; Dir: TRichtung);
var Horizontal_Abstand, Vertikal_Abstand, Abstand: integer;
    Sichtweite: integer;
    x,y,x2,y2: integer;
    Sichtende: boolean;
begin
  PB.Refresh;
  Vertikal_Abstand:= PB.Width;
  Horizontal_Abstand:= PB.Height;
  if Horizontal_Abstand<Vertikal_Abstand then Abstand:= Horizontal_Abstand else Abstand:= Vertikal_Abstand;
  Sichtweite:= 0;
  x:= Pos.x;
  y:= Pos.y;
  case Dir of
    ost: begin x2:= x+1; y2:= y; end;
    nord: begin y2:= y-1; x2:= x; end;
    west: begin x2:= x-1; y2:= y; end;
    sued: begin y2:= y+1; x2:= x; end;
  end;

  Sichtende:= false;
  Repeat
    Case Sichtweite of
      0: begin

         end;
    end;
    Sichtende:= (Grenze = IrrFeld.Feld[x2,y2]);
    Case Dir of
      ost: begin x:= x+2; x2:= x2+2; end;
      nord: begin y:= y-2; y2:= y2-2; end;
      west: begin x:= x-2; x2:= x2-2; end;
      sued: begin y:= y+2; y2:= y2+2; end;
    end;
  until Sichtende;
end;

end.
